"use strict";

var events = []; // 日程需要的数据

var agenda = $('#agenda');
$(function () {
  agenda.fullCalendar({
    locale: 'zh-cn',
    defaultView: 'month',
    selectHelper: true,
    selectable: true,
    header: {
      left: 'prev,next',
      center: 'title',
      right: 'month,agendaWeek,agendaDay,agendaFourDay'
    },
    views: {
      agendaFourDay: {
        type: 'agenda',
        duration: {
          days: 4
        }
      }
    },
    timeFormat: 'HH:mm',
    eventTextColor: '#212121',
    eventBackgroundColor: '#cfe4f8',
    events: events,
    firstDay: 0,
    select: agendaFunc.handleSelect,
    eventClick: agendaFunc.handleEventClick,
    eventRender: agendaFunc.handleEventRender
  }); // 单击prev/next按钮

  $('#agenda .fc-prev-button, #agenda .fc-next-button').click(function () {
    var currentDate = getCalendarDate(agenda);

    if (isMonthView(agenda)) {
      app.selectCalendarCells(currentDate);
    }

    callPC('changePcDate', currentDate);
  }); // ready

  callPC('ready');
});