"use strict";

function isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _construct(Parent, args, Class) { if (isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function contextMenuInit() {
  // 右键菜单
  $(document).contextmenu(function (e) {
    e.stopPropagation();
    var mailId = '';
    var params = {};
    var paramsAll = [];
    var user = {};
    var target = e.target;
    var dom = document.querySelector('.detail-button');

    dom.oncopy = function () {
      return false;
    };

    mailId = $(target).parents('.mail-box').data('mailid');
    var mail = getMailByMailId(mailId);
    params['mailId'] = mailId;

    if ($(target).hasClass('user') && $(target).parent().attr('id') || $(target).hasClass('email-address')) {
      // 自定义邮箱账号右键菜单
      e.preventDefault();
      var selection = window.getSelection();
      var range = selection.getRangeAt(0);
      var str = selection.toString();
      removeSelectedAttachments(mailId);
      var userDom = $(target).hasClass('user') ? $(target) : $(target).parent();
      var userType = +userDom.parent().attr('id').split('_')[1];
      var userArr = getEffectiveUserInfo(str);
      var userAll = [];

      for (var i = 0; i < userArr.length; i++) {
        user = {};
        user['name'] = userArr[i].name;
        user['email'] = userArr[i].email;
        userAll.push(user);
      }

      params['mailId'] = mailId;
      params['userType'] = userType;
      params['user'] = userAll;
      paramsAll.push(params);

      var paramsObj = _construct(Object, paramsAll);

      if (userAll.length == 0) {
        params = {};
        params['mailId'] = mailId;
        params['type'] = 0;
        params['userType'] = +userDom.parent().attr('id').split('_')[1];
        params['name'] = String(userDom.data('name'));
        params['email'] = String(userDom.attr('title'));
        setTimeout(function () {
          callPC('showMenu', params);
        }, 60); // 单个点击复制

        selectUser(userDom[0]);
      } else {
        setTimeout(function () {
          callPC('showUserMenu', paramsObj);
        }, 60);
      }
    } else if ($(target).hasClass('attachment-item') || $(target).parent().hasClass('attachment-item')) {
      // 自定义附件右键菜单
      e.preventDefault();
      var attachment = $(target).hasClass('attachment-item') ? $(target) : $(target).parent();
      var params = {
        type: 1,
        mailId: mailId,
        fileId: []
      };

      if (attachment.hasClass('attachment-item-selected')) {
        var selectedAttachments = mail.find('.mail-attachments .attachment-item-selected');
        var endFileId = $(attachment).data('fileid').toString();
        selectedAttachments.each(function () {
          var fileId = $(this).data('fileid').toString();
          if (fileId !== endFileId) params['fileId'].push(fileId);
        });
        params['fileId'].push(endFileId);
      } else {
        mail.find('.mail-attachments .attachment-item-selected').removeClass('attachment-item-selected');
        attachment.addClass('attachment-item-selected');
        var fileId = $(attachment).data('fileid').toString();
        params['fileId'].push(fileId);
      }

      setTimeout(function () {
        callPC('showMenu', params);
      }, 60);
    } else if ($(target).hasClass('detail-button')) {
      e.preventDefault();
    } else {
      removeSelectedAttachments(mailId); // 清除附件选中效果
    }
  });
}