"use strict";

function _createForOfIteratorHelper(o) {
  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (o = _unsupportedIterableToArray(o))) {
      var i = 0;var F = function F() {};return { s: F, n: function n() {
          if (i >= o.length) return { done: true };return { done: false, value: o[i++] };
        }, e: function e(_e) {
          throw _e;
        }, f: F };
    }throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }var it,
      normalCompletion = true,
      didErr = false,
      err;return { s: function s() {
      it = o[Symbol.iterator]();
    }, n: function n() {
      var step = it.next();normalCompletion = step.done;return step;
    }, e: function e(_e2) {
      didErr = true;err = _e2;
    }, f: function f() {
      try {
        if (!normalCompletion && it["return"] != null) it["return"]();
      } finally {
        if (didErr) throw err;
      }
    } };
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;if (typeof o === "string") return _arrayLikeToArray(o, minLen);var n = Object.prototype.toString.call(o).slice(8, -1);if (n === "Object" && o.constructor) n = o.constructor.name;if (n === "Map" || n === "Set") return Array.from(n);if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }return arr2;
}

// 获取域名，sid，新手指引是否显示
function getUrl(func) {
  var pathName = app.apiServer;

  var _func = encodeURIComponent(func);

  var _sid = app.sid;
  var reqUrl = pathName + '/s/json' + '?func=' + _func + '&sid=' + _sid;
  return reqUrl;
} //get封装


jQuery._get = function (url, successfn) {
  data = data == null || data == "" || typeof data == "undefined" ? {
    "date": new Date().getTime()
  } : data;
  $.ajax({
    type: "get",
    data: data,
    url: getUrl(url),
    dataType: "json",
    success: function success(d) {
      successfn(d);
    }
  });
}; // post封装


jQuery._post = function (url, data, successfn) {
  data = data == null || data == "" || typeof data == "undefined" ? {
    "date": new Date().getTime()
  } : data;
  $.ajax({
    type: "post",
    url: getUrl(url),
    data: JSON.stringify(data),
    contentType: "text/x-json",
    dataType: "json",
    success: function success(res) {
      if (res.code === 'S_OK') successfn(res);
    },
    error: function error(e) {}
  });
}; //获取"周X"格式


function week(day) {
  switch (day.weekday()) {
    case 1:
      return '周一 ';
      break;

    case 2:
      return '周二 ';
      break;

    case 3:
      return '周三';
      break;

    case 4:
      return '周四 ';
      break;

    case 5:
      return '周五 ';
      break;

    case 6:
      return '周六 ';
      break;

    case 0:
      return '周日 ';
      break;

    default:
      break;
  }
} // 返回日历所选时间


function selectedDate() {
  return $('.fc-toolbar>.fc-center h2').text().split(' ')[0].replace(/\./gi, '-');
} // 根据日历视图类型获取一天或三天数据


function endDate() {
  var toDate = '';
  var viewType = $('.fc-view-container > .fc-view').hasClass('fc-agendaThreeDays-view');
  var selectedDay = selectedDate();
  if (viewType) toDate = moment(selectedDay).add(2, 'd').format('YYYY-MM-DD');else toDate = selectedDay;
  return toDate;
} // 获取会议室预定情况


function getEvent(url, data, resId) {
  if (resId.match(/^notNeedMeetingRoom/) === null) {
    var booked = [];
    data['resId'] = resId;
    callPC('getAboutEvent', data);
  }
} //获取所有会议室预定情况


// function getAllMeeting() {
//   var indexData = {
//     conditions: [{
//       field: "@type",
//       operator: "=",
//       operand: "R"
//     }],
//     dn: app.dn,
//     returnAttrs: ["true_name", "email"],
//     windowSize: 500
//   };

//   $._post('oab:searchEx', indexData, function (data) {
//     var roomsList = data["var"];
//     $('.list-content ul').append($('<li>').text('无需会议室'));
//     var notNeedRoom = $('.list-content ul li:first');
//     notNeedRoom.addClass('list-active');
//     rooms.push({
//       id: 'notNeedMeetingRoom',
//       title: '无需会议室'
//     });
//     fc.fullCalendar('refetchResources'); //会议室为空

//     if (roomsList.length === 0) {
//       notNeedRoom.click(function () {
//         if (!$(this).hasClass('list-active')) {
//           $(this).addClass('list-active');
//           rooms.push({
//             id: 'notNeedMeetingRoom',
//             title: '无需会议室'
//           });
//           fc.fullCalendar('refetchResources');
//         } else {
//           $(this).removeClass('list-active');
//           var mid = rooms.findIndex(function (room) {
//             return room.id === 'notNeedMeetingRoom';
//           });
//           rooms.splice(mid, 1);
//           fc.fullCalendar('refetchResources');
//         }
//       });
//     } else {
//       //会议室不为空
//       $('.chose-all').show();
//       notNeedRoom.on('click', function () {
//         if (!$(this).hasClass('list-active')) {
//           $('.list-content ul li').removeClass('list-active');
//           $(this).addClass('list-active');
//           rooms.splice(0, rooms.length);
//           rooms.push({
//             id: 'notNeedMeetingRoom',
//             title: '无需会议室'
//           });
//           $('#checked').hide();
//           fc.fullCalendar('refetchResources');
//         } else {
//           $(this).removeClass('list-active');
//           var mid = rooms.findIndex(function (room) {
//             return room.id === 'notNeedMeetingRoom';
//           });
//           rooms.splice(mid, 1);
//           fc.fullCalendar('refetchResources');
//         }
//       });

//       var _iterator = _createForOfIteratorHelper(roomsList),
//           _step;

//       try {
//         var _loop = function _loop() {
//           var item = _step.value;
//           $('.list-content ul').append($('<li>').text(item.true_name));
//           el = $('.list-content ul li:last'); // 会议室hover提示

//           el.mouseenter(function () {
//             var that = $(this);
//             layers.tips(item.true_name, that, {
//               tips: 2,
//               tipsMore: true,
//               time: 0,
//               anim: 5,
//               skin: 'room-hover-tips'
//             });
//           });
//           el.mouseleave(function () {
//             layers.close(layers.index);
//           });
//           $('.list-content ul').click(function () {
//             layer.closeAll('tips');
//           }); // 会议室click事件

//           $('.list-content ul li:last').on('click', function () {
//             if (!$(this).hasClass('list-active')) {
//               $(this).addClass('list-active');

//               if (notNeedRoom.hasClass('list-active')) {
//                 notNeedRoom.removeClass('list-active');
//                 var mid = rooms.findIndex(function (room) {
//                   return room.id === 'notNeedMeetingRoom';
//                 });
//                 rooms.splice(mid, 1);
//               }

//               rooms.push({
//                 id: item.email,
//                 title: item.true_name
//               });
//               fc.fullCalendar('refetchResources');
//               getEvent('cal:getUserFreeBusyStatus', {
//                 fromdate: selectedDate() + ' 0:00',
//                 m: true,
//                 todate: endDate() + ' 23:59',
//                 toweb: true,
//                 user_id: item.email
//               }, item.email);
//             } else {
//               if ($('#checked').css('display').match(/[none]/)) $('#checked').hide();
//               $(this).removeClass('list-active');
//               var mid = rooms.findIndex(function (room) {
//                 return room.id === item.email;
//               });
//               rooms.splice(mid, 1);
//               fc.fullCalendar('refetchResources');
//             }
//           });
//         };

//         for (_iterator.s(); !(_step = _iterator.n()).done;) {
//           var el;

//           _loop();
//         }
//       } catch (err) {
//         _iterator.e(err);
//       } finally {
//         _iterator.f();
//       }
//     }

//     $('.chose').click(function () {
//       // 全选按钮请求全部数据
//       $('#checked').show();
//       $('.chose-all span').css('color', '#212121');
//       $('.list-content ul li:not(:first)').addClass('list-active');
//       if (notNeedRoom.hasClass('list-active')) notNeedRoom.removeClass('list-active');
//       rooms.splice(0, rooms.length);
//       roomsList.forEach(function (item) {
//         rooms.push({
//           id: item.email,
//           title: item.true_name
//         });
//       });
//       fc.fullCalendar('refetchResources');
//       rooms.forEach(function (item) {
//         return getEvent('cal:getUserFreeBusyStatus', {
//           fromdate: selectedDate() + ' 0:00',
//           m: true,
//           todate: endDate() + ' 23:59',
//           toweb: true,
//           user_id: item.id
//         }, item.id);
//       });
//     });
//     $('#checked').click(function () {
//       //取消全选
//       $('#checked').hide();
//       $('.chose-all span').css('color', '#666666');
//       $('.list-content ul li').removeClass('list-active');
//       rooms.splice(0, rooms.length);
//       fc.fullCalendar('refetchResources');
//     });
//   });
// } 
// 设置日历不高亮，不限制选择


function notHightLight() {
  var aboveEvent = fc.fullCalendar('clientEvents', 'aboveHightLight');
  var underEvent = fc.fullCalendar('clientEvents', 'underHightLight');
  if (aboveEvent.length !== 0) fc.fullCalendar('removeEvents', 'aboveHightLight');
  if (underEvent.length !== 0) fc.fullCalendar('removeEvents', 'underHightLight');
  fc.fullCalendar('option', {
    validRange: {
      start: '',
      end: ''
    }
  });
} // 设置特定时间段可选择和高亮,日期格式YYYY-MM-DD,时分格式00:00至23:59,不可以出现0:00


function setHightLight(startTime, endTime) {
  var dayOfStart = startTime.split(' ');
  var dayOfEnd = endTime.split(' ');
  if (dayOfEnd[1].match(/^23:59/) !== null) dayOfEnd[1] = '24:00';
  fc.fullCalendar('option', {
    validRange: {
      start: dayOfStart[0],
      end: moment(dayOfEnd[0]).add(1, 'd').format('YYYY-MM-DD')
    }
  });
  var aboveEvent = fc.fullCalendar('clientEvents', 'aboveHightLight');

  if (aboveEvent.length === 0) {
    if (dayOfStart[1].match(/^00:00/) === null) {
      fc.fullCalendar('renderEvent', {
        id: 'aboveHightLight',
        start: "".concat(moment(startTime).format('YYYY-MM-DD'), " 00:00:00"),
        end: startTime,
        rendering: 'background',
        color: '#dddddd'
      }, true);
    }
  } else {
    if (dayOfStart[1].match(/^00:00/) !== null) fc.fullCalendar('removeEvents', 'aboveHightLight');else {
      var above = aboveEvent[0];
      above.start = moment("".concat(moment(startTime).format('YYYY-MM-DD'), " 00:00:00")), above.end = moment(startTime), fc.fullCalendar('updateEvent', above);
    }
  }

  var underEvent = fc.fullCalendar('clientEvents', 'underHightLight');

  if (underEvent.length === 0) {
    fc.fullCalendar('renderEvent', {
      id: 'underHightLight',
      start: "".concat(dayOfEnd[0], " ").concat(dayOfEnd[1]),
      end: "".concat(moment(endTime).format('YYYY-MM-DD'), " 24:00"),
      rendering: 'background',
      color: '#dddddd'
    }, true);
  } else {
    var under = underEvent[0];
    under.start = moment("".concat(dayOfEnd[0], " ").concat(dayOfEnd[1])), under.end = moment("".concat(moment(endTime).format('YYYY-MM-DD'), " 24:00")), fc.fullCalendar('updateEvent', under);
  }
} // 绑定按钮单击事件


function bindButtonClickEvent() {
  var currentDate = fc.fullCalendar('getDate').format('YYYY-MM-DD'); // 返回当前时间

  var currentThrDate = fc.fullCalendar('getDate').add(2, 'd').format('YYYY-MM-DD'); // 返回当前未来三天时间
  // 今天按钮

  $('.fc-today-button').click(function () {
    rooms.forEach(function (item) {
      return getEvent('cal:getUserFreeBusyStatus', {
        fromdate: currentDate + ' 0:00',
        m: true,
        todate: currentThrDate + ' 23:59',
        toweb: true,
        user_id: item.id
      }, item.id);
    });
  }); //当前按钮

  $('.fc-agendaDay-button').click(function () {
    $('.fc-agendaThreeDays-button').attr('disabled', false);
  }); //近三天按钮

  $('.fc-agendaThreeDays-button').click(function () {
    rooms.forEach(function (item) {
      return getEvent('cal:getUserFreeBusyStatus', {
        fromdate: selectedDate() + ' 0:00',
        m: true,
        todate: endDate() + ' 23:59',
        toweb: true,
        user_id: item.id
      }, item.id);
    });
    $('.fc-agendaThreeDays-button').attr('disabled', true);
  }); // prev,next按钮

  $('.fc-next-button,.fc-prev-button').click(function () {
    rooms.forEach(function (item) {
      return getEvent('cal:getUserFreeBusyStatus', {
        fromdate: selectedDate() + ' 0:00',
        m: true,
        todate: endDate() + ' 23:59',
        toweb: true,
        user_id: item.id
      }, item.id);
    });
  });
} // 新手指引控制


function newGuideControl() {
  $('.guide-button').before('<img width="990" height="616" name="guide" src="./static/img/guide.png" id="introImg"></video>');
  $('.guide').show(); //控制新手指引

  $('#know-no').click(function () {
    $('.guide').hide();
    callPC('notDisplayGuideMov', '0');
  });
  $('#cancel').click(function () {
    $('.guide').hide();
  });
}