"use strict";

function cliboardHandler() {
  // 右键复制去掉“详细信息”
  document.addEventListener("copy", function (e) {
    e.preventDefault();
    var selection = window.getSelection();
    var selObj = selection.toString();
    var selStr = selObj.replace('隐藏信息', '');
    selStr = selStr.replace('详情信息', '');
    e.clipboardData.setData('text', selStr);
  }, true); // ctrl + c 去掉“详细信息”

  document.onkeydown = function (e) {
    if (e.ctrlKey && e.keyCode == 67) {
      //ctrl+C
      var handler = function handler(event) {
        var selection = window.getSelection();
        var selObj = selection.toString();
        var selStr = selObj.replace('隐藏信息', '');
        selStr = selStr.replace('详情信息', '');
        event.clipboardData.setData('text', selStr);
        document.removeEventListener('copy', handler, true);
        event.preventDefault();
      };

      document.addEventListener('copy', handler, true);
    }
  };
}