"use strict";

var app = {};
Object.keys(api).forEach(function (key) {
  Object.defineProperty(app, key, {
    enumerable: false,
    configurable: false,
    value: function value() {
      var args = [].slice.call(arguments);
      console.log("".concat(key, "---"), args[0]);
      api[key].apply(api, args);
    }
  });
});
window.app = app; // c++调js的接口

var callPC = function callPC() {
  var funcName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var strArgs = JSON.stringify(args);
  //window.CoreMail(funcName, strArgs); // js通知c++的接口
  window.location.assign("coremail://" + funcName + "?" + strArgs);
  console.log('callPC-->', funcName, strArgs);
};

template.helper('formatCalendarStatus', formatCalendarStatus);
window.zoomLevel = 1;
window.onresize = windowResized;
$(window).scroll(function (e) {
  mailRender.mailInfoGroup.forEach(function (mail) {
    var iframe = document.getElementById("iframe_".concat(mail.mailId));
    var mailContent = $(iframe).parent();
    var scrollBar = mailContent.find('#scroll-inside');

    if (scrollBar.css('display') !== 'none') {
      var clientRect = iframe.getBoundingClientRect();
      var originWidth = $('#scroll-inside').width() - 150;

      if (clientRect.bottom > 0 && clientRect.bottom > window.innerHeight) {
        if ($('#scroll-inside').css('position') === 'absolute') {
          $('#scroll-inside').css('position', 'fixed');
          var newWidth = $('#scroll-inside').width() - 150;
          var leftNum = parseInt($('.scroll-rect').css('left'));

          if (!isNaN(leftNum)) {
            $('.scroll-rect').css('left', newWidth * leftNum / originWidth);
          }
        }
      } else if ($('#scroll-inside').css('position') === 'fixed') {
        $('#scroll-inside').css('position', 'absolute');
        var newWidth = $('#scroll-inside').width() - 150;
        var leftNum = parseInt($('.scroll-rect').css('left'));

        if (!isNaN(leftNum)) {
          $('.scroll-rect').css('left', newWidth * leftNum / originWidth);
        }
      }
    }
  });
});

$(document).on("keydown", function (ev) {
  callPC('keydown', { 
    "code" : ev.key
   });
});

$(document).ready(function () {
  clickHandlerInit();
  contextMenuInit();
  cliboardHandler(); // 过滤掉“详细信息”和“隐藏信息”

  callPC('ready');
});